/*
  Copyright (C) 2004 Hideo Bannai (bannai@ims.u-tokyo.ac.jp)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

#ifndef FASTAFILE_H
#define FASTAFILE_H

#include <string>
#include <map>

/** A single entry of a FastA format file. */
class FastaEntry {
	std::string nm;
	std::string sq;
public:
	FastaEntry(const std::string & name,
			   const std::string & seq){
		nm = name; sq = seq;			
	}
	const std::string & get_sequence() const { return sq; }
	const std::string & get_name() const { return nm; }
//		 	~FastaEntry();
};

/** Class for reading multi-FastA format files. */
class FastaFile{
public:
	static void read(const std::string & filename,
                	 std::multimap<std::string,FastaEntry> & db);
};

#endif // FASTAFILE_H
