/*
  Copyright (C) 2004 Hideo Bannai (bannai@ims.u-tokyo.ac.jp)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

#include "Scores.h"
#include <math.h>

double Scores::ranksumtest(std::size_t n1,
			   std::size_t n2,
			   double ranksum1,
			   double variance_correction){
  if(n1 && n2){
    std::size_t N = n1+n2;
    double dn1 = n1, dn2 = n2;
    double dN = N;
    double U1 = dn1 * dn2 + (dn1 * (dn1 + 1.0) / 2.0) - ranksum1;
    double numer = U1 - (dn1 * dn2 / 2.0);
    // double denom = sqrt(dn1 * dn2 * (dn1 + dn2 + 1.0) / 12.0);
    double denom = sqrt((dn1 * dn2 / (dN * (dN - 1)))
			* (((dN/12.0) * (dN * dN - 1.0)) - variance_correction));
    return(numer/denom);
  } else {
    return(0.0);
  }
}
