/*
  Copyright (C) 2004 Hideo Bannai (bannai@ims.u-tokyo.ac.jp)
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
*/

#include <iostream>
#include <boost/test/unit_test.hpp>
#include "../FastaFile.h"

using namespace std;
using namespace boost::unit_test_framework;

void FastaFile_test(){
	multimap<string,FastaEntry> db;
	multimap<string,FastaEntry>::iterator it;
	FastaFile::read("FastaFile_test.txt", db);
	for(it = db.begin(); it != db.end(); it++){
		cout << "Name: '" << (*it).first << "'" << endl;
		cout << "Seq : '" << (*it).second.get_sequence() << "'" << endl;	
	}
}

test_suite* init_unit_test_suite( int argc, char* argv[] )
{
  test_suite* test = BOOST_TEST_SUITE( "FastaFile test" );
  test->add(BOOST_TEST_CASE(FastaFile_test));
  return test; 
}
